#include <MIDI.h>
MIDI_CREATE_DEFAULT_INSTANCE();
byte chn = 2; // midi channel
byte pushButton13 = 13; // midi gate IN
byte PadNote[36] = {36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71}; // 36 NOTES
byte note = 0;
byte velo = 0;
boolean buttonState13 = 0;
boolean note13 = 0;

byte pwmPinX = 10;   // output pin supporting PWM cv1 out
byte pwmPinY = 12; // output pin supporting PWM cv2 out
byte gatePinZ = 9; // output pin Digital 9 gate out
byte ledZ = 11; // output pin Digital 11 gate out indicator

int valx = 0; // variable to store the read value
int valy = 0;
int valz = 0;
int gateSensi = 0;

byte resultx = 0;
byte resulty = 0;
int resultz = 0;

const int sPin = A0; // analog pin 0 Pot gate sensi
const int xPin = A1;  // x-axis of the accelerometer
const int zPin = A2;  // Z
const int yPin = A3;  // y-axis


void setup()
{
//Serial.begin(9600);
pinMode(pushButton13, INPUT);
pinMode(pwmPinX, OUTPUT); // sets the pin as output
pinMode(pwmPinY, OUTPUT); 
pinMode(ledZ, OUTPUT);
pinMode(gatePinZ, OUTPUT);
MIDI.begin();
}

void loop()
{
buttonState13 = digitalRead(pushButton13);

valx = analogRead(xPin); // read the input pin
valy = analogRead(yPin); 
valz = analogRead(zPin); 
gateSensi = analogRead(sPin);

note = map (valx, 262, 395, 0, 36);
velo = map (valy, 266, 396, 0, 127);

resultx = map(valx, 262 , 395, 0, 255); //min 262 max 395
resulty = map(valy, 266 , 396, 0, 255); //min 265 max 397
resultz = map(gateSensi, 0 , 1023, 403, 667); // z sensi

if (buttonState13 == HIGH) {
    if (note13 == 0) {
      MIDI.sendNoteOn(PadNote[note], velo, chn);
      note13 = 1;
    }
  } else {
    if (note13 == 1) {
      MIDI.sendNoteOff(PadNote[note], 0, chn);
    }
    note13 = 0;
  }

if (valz >= resultz)
  {
    digitalWrite(ledZ, HIGH);
    digitalWrite(gatePinZ, HIGH);
  }
  else
  {
    digitalWrite(ledZ, LOW);
    digitalWrite(gatePinZ, LOW);
  }
  
analogWrite(pwmPinX, resultx);
analogWrite(pwmPinY, resulty);

// print the sensor values:
  //Serial.print(analogRead(xPin));
  // print a tab between values:
  //Serial.print("\t");
  //Serial.print(analogRead(yPin));
  // print a tab between values: 
  //Serial.print("\t");
  //Serial.print(analogRead(zPin)); 
  // print a tab between values:
  //Serial.println();
  // delay before next reading:
  //delay(500);
  delay(1);
}

